package aacs.decoder;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Hashtable;

public class DecryptEVOB {

    public static int CHUNK_LEN= 32*1024; // Read Buffer

    public static void decryptEVOBFile(File source, File destination, Hashtable keys){
        try{
            byte[] pack = null;
            FileInputStream fis = new FileInputStream(source);
            FileOutputStream fos = new FileOutputStream(destination);
            pack = new byte[2048];
            byte[] currentChunk = new byte[CHUNK_LEN];
            loadChunk(currentChunk,fis,CHUNK_LEN);
            int blockCounter=0;
            int packPerChunk = CHUNK_LEN/2048;
            boolean finish=false;
            int c=0;
            int currentKey=0;
            byte[] CurrentCPIField=new byte[16];
            while (!finish){
                System.arraycopy(currentChunk,blockCounter*2048,pack,0,2048);
                EVOBPack aPack= new EVOBPack(pack);
                if (aPack.isNavpack){
                    CurrentCPIField=aPack.CPIField;
                    currentKey=aPack.titleKey;
                }
                if (aPack.isEncrypted){
                    byte[] key =(byte[])keys.get(currentKey);
                    aPack.decryptPACK(key,CurrentCPIField);
                }

                fos.write(aPack.HeaderPart);
                fos.write(aPack.EncryptedPart);

                c++;
                blockCounter++;
                if (blockCounter==packPerChunk){
                    blockCounter=0;
                    int red=loadChunk(currentChunk,fis,CHUNK_LEN);
                    if (red==0){
                        finish=true;
                    }else
                    if (red!=CHUNK_LEN){
                        packPerChunk=red/2048;
                    }
                }
            }
            fis.close();
            fos.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    public static int loadChunk(byte[] buffer, FileInputStream inputStream, int blockLen){
        int total=0;
        try{
        int red=0;
        total=inputStream.read(buffer);
        if (total==-1){
            return 0;
        }
        boolean endOfFile=false;
        while (total!=blockLen&&!endOfFile){
            red=inputStream.read(buffer,total,blockLen-total);
            if (red==-1){
                endOfFile=true;
            }else total=total+red;
        }
        }catch(Exception e){
            e.printStackTrace();
            System.exit(0);
    }

        return total;
    }

}
